package hr.fer.ga.imgcompression;
import java.awt.Color;
import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.jgap.Chromosome;
import org.jgap.Configuration;
import org.jgap.Genotype;
import org.jgap.IChromosome;
import org.jgap.InvalidConfigurationException;
import org.jgap.impl.DefaultConfiguration;

/**
 * 
 */

/**
 * Klasa za testiranje kompresora slika
 * 
 * Za implementiranje genetskog algoritma koriten je JGAP (Java genetic algorithms package) library:
 * http://jgap.sourceforge.net/
 */
public class CompressorTester {

	/**
	 * 
	 * 
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		ImageCompressor imgcomp = new ImageCompressor();
		File imageFile = new File(args[0]);
		File resultFile = new File(args[1]);
		
		int precentage = 0;
		
		try {
			precentage = Integer.parseInt(args[2]);
		} catch(NumberFormatException e) {
			System.out.println("Postotak kompresije nije ispravno zadan!");
			return;
		}
		
		imgcomp.load(imageFile);
		imgcomp.setDestinationImage(resultFile);
		System.out.println("compression started: ");
		imgcomp.setCompressionPrecentage(precentage);
		imgcomp.compress();
	}

	
}
