package hr.fer.ga.imgcompression;
/**
 * 
 */
import java.awt.Color;
import java.util.Random;

/**
 * Alel koji predstavlja vrijednost pixela slike.
 */
public class PixelAllele implements Comparable<PixelAllele> {

	/** x koordianata pixela u slici */
	private int x;
	
	/** y koordinata pixela u slici */
	private int y;
	
	/** boja pixela */
	private Color color;
	
	/** vrijednost x ili y koordinate koja oznauje da koordinata nije postavljena */
	public final static int COORDINATE_NOT_SET = -1;
	
	private int id;
	
	private static Random random = new Random();

	/**
	 * 
	 * @param x
	 * @param y
	 * @param color
	 */
	public PixelAllele(int x, int y, Color color) {
		super();
		if(x < 0) {
			this.x = COORDINATE_NOT_SET;
		} else {
			this.x = x;
		}
		if(y <0) {
			this.y = COORDINATE_NOT_SET;
		} else {
			this.y = y;
		}
		this.color = color;
	}

	public int getX() {
		return x;
	}
	
	public int getY() {
		return y;
	}
	
	public Color getColor() {
		return color;
	}

	/**
	 * Metoda za usporedbu koja se korsiti za sortiranje alela
	 * prema poloaju pixela u slici.
	 * 
	 */
	@Override
	public int compareTo(PixelAllele o) {
		if(this.y == o.y) {
			if(this.x == o.x) {
				return 0;
			} else if(this.x > o.x) {
				return 1;
			} else {
				return -1;
			}
		} else if(this.y > o.y) {
			return 1;
		} else {
			return -1;
		}
	}

	
	@Override
	public String toString() {
		return "[" + id + ", " + x + ", " + y + " " + color + "]";
	}
}
