/**
 * 
 */
package hr.fer.ga.imgcompression.clustering;

import java.awt.Color;

import hr.fer.ga.imgcompression.PixelAllele;
import hr.fer.ga.imgcompression.PixelGene;

import org.jgap.Chromosome;
import org.jgap.Configuration;
import org.jgap.Gene;
import org.jgap.IChromosome;

/**
 * @author Ivan Kut
 *
 */
public class FixedClusterer extends Clusterer {

	/** broj razreda u koji se rasporeuju objekti */
	private int numberOfClusters;
	
	public void setNumberOfClusters(int numberOfClusters) {
		this.numberOfClusters = numberOfClusters;
	}
	
	public int getNumberOfClusters() {
		return numberOfClusters;
	}
	
	@Override
	public Gene[] doClustering(IChromosome chromosome) {
		System.out.print("Rasporeujem pixele (FixedClustering) predstavljene kromosomom " 
				+ chromosome.getFitnessValue() + " u razrede...");
		if(numberOfClusters < 1)
			numberOfClusters = 1;
		
		int objectsPerCluster = (int)Math.ceil(chromosome.size() / numberOfClusters);
		Gene genes[] = chromosome.getGenes();
		PixelAllele currentAllele;	
		
		if(objectsPerCluster <= 1) return genes;
		
		int redCentroid;
		int greenCentroid;
		int blueCentroid;
		int alphaCentroid;
		
		for(int i = 0; i < numberOfClusters; i++) {
			redCentroid = 0;
			greenCentroid = 0;
			blueCentroid = 0;
			alphaCentroid = 0;
			for(int j = 0; j < objectsPerCluster; j++) {
				currentAllele = (PixelAllele)genes[i * objectsPerCluster + j]
					                     .getAllele();
			/*	redCentroid += genes[i * objectsPerCluster + j]
				                     .getAllele().getColor().getRed();
				greenCentroid += genes[i * objectsPerCluster + j]
				                     .getAllele().getColor().getRed();
				blueCentroid += genes[i * objectsPerCluster + j]
				                     .getAllele().getColor().getRed();
				alphaCentroid += genes[i * objectsPerCluster + j]
				                     .getAllele().getColor().getRed();		*/
				redCentroid += currentAllele.getColor().getRed();
				greenCentroid += currentAllele.getColor().getGreen();
				blueCentroid += currentAllele.getColor().getBlue();
				alphaCentroid += currentAllele.getColor().getAlpha();
			}
			redCentroid = redCentroid / objectsPerCluster;
			greenCentroid = greenCentroid / objectsPerCluster;
			blueCentroid = blueCentroid / objectsPerCluster;
			alphaCentroid = alphaCentroid / objectsPerCluster;
			
			for(int j = 0; j < objectsPerCluster; j++) {
				currentAllele = (PixelAllele)genes[i * objectsPerCluster + j]
								                     .getAllele();
			/*	int x = genes[i * objectsPerCluster + j].getAllele().getX();
				int y = genes[i * objectsPerCluster + j].getAllele().getY(); */
				int x = currentAllele.getX();
				int y = currentAllele.getY();
				
				//pGenes[i * objectsPerCluster + j] = new PixelGene())
				genes[i * objectsPerCluster + j].setAllele(new PixelAllele(x, y, 
						new Color(redCentroid, greenCentroid, blueCentroid, alphaCentroid)));
			}
		}
		
		System.out.println("gotov");
		return genes;
	} 
}
